"""
unit tests for module logilab.common.patricia
"""

__revision__ = "$Id: unittest_patricia.py,v 1.1 2003/02/17 10:03:16 syt Exp $"

import unittest
from logilab.common.patricia import *

    
class PatriciaTrie_ClassTest(unittest.TestCase):
    
    def knownValues(self):
        """ 
        remove a child node
        """
        p = PatriciaTrie()
        i = 0
        words_list = ['maitre', 'maman', 'mange', 'manger', 'mangouste',
                      'manigance', 'manitou']
        words_list.sort()
        #
        for i in range(len(words_list)):
            p.insert(words_list[i], i)
        for i in range(len(words_list)):
            assert p.lookup(words_list[i]) == [i]
        try:
            p.lookup('not in list')
            raise AssertionError()
        except KeyError:
            pass
        #
        l = p.pfx_search('')
        l.sort()
        assert l == words_list
        l = p.pfx_search('ma')
        l.sort()
        assert l == words_list
        l = p.pfx_search('mai')
        assert l == ['maitre']
        l = p.pfx_search('not in list')
        assert l == []
        l = p.pfx_search('man', 2)
        assert l == ['mange']
        l = p.pfx_search('man', 1)
        assert l == []
        p.remove('maitre')
        try:
            print p.lookup('maitre')
            raise AssertionError()
        except KeyError:
            pass
        print p
    
def Run():
    testsuite = unittest.TestSuite()
    testsuite.addTest(PatriciaTrie_ClassTest("knownValues"))
    test = unittest.TextTestRunner()
    # uncomment next line to write tests results in a file
    #test.__init__(open('tests.log','w+'))    
    return test.run(testsuite)
    
if __name__ == '__main__':
    Run()
